/*-------------------------------------------------------------------------------------------------------------------*/
/**
 *    \file       Os_GlobalDefs.h
 *    \author     Nicolae-Bogdan Bacrau
 *    \brief      Defines all the global macros and types that are needed for starting the OS from the exterior.
 */
/*-------------------------------------------------------------------------------------------------------------------*/

#ifndef OS_GLOBALDEFS_H
#define OS_GLOBALDEFS_H

/*-------------------------------------------------------------------------------------------------------------------*/
/*                                                     Inclusions                                                    */
/*-------------------------------------------------------------------------------------------------------------------*/

#include "Std_Types.h"

/*-------------------------------------------------------------------------------------------------------------------*/
/*                                            Definition Of Global Macros                                            */
/*-------------------------------------------------------------------------------------------------------------------*/

/** \brief  Function-like macro for declaring and defining OS tasks.
 *
 * The pre-processor concatenation is used as suggested in the OSEK 2.2.3 specifications page 54. */
#define TASK(taskName)                       void FUNC_ ## taskName(void)

/** \brief  Function-like macro for declaring and defining interrupt service routines. */
#define ISR(isrName)                         void ISR_ ## isrName(void)

/** \brief  Macro which defines the default (and only) OS application mode. */
#define OSDEFAULTAPPMODE                     ((AppModeType) 0U)

/*-------------------------------------------------------------------------------------------------------------------*/
/*                                          Definition Of Global Data Types                                          */
/*-------------------------------------------------------------------------------------------------------------------*/

/** \brief  Type which identifies OS application modes. */
typedef uint8 AppModeType;

/*-------------------------------------------------------------------------------------------------------------------*/
/*                                             Export Of Global Variables                                            */
/*-------------------------------------------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------------------------------------------*/
/*                                             Export Of Global Constants                                            */
/*-------------------------------------------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------------------------------------------*/
/*                                             Export Of Global Functions                                            */
/*-------------------------------------------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------------------------------------------*/
#endif /* OS_GLOBALDEFS_H */
